"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const express_1 = __importStar(require("express"));
const path_1 = __importDefault(require("path"));
const morgan_1 = __importDefault(require("morgan"));
const uikit = require.resolve('uikit');
const index_1 = require("./routes/index");
const upload_1 = require("./routes/upload");
const download_1 = require("./routes/download");
function setLogging(app, loggingLevel, stdout) {
    const format = ':method request for :url resulted in status code :status - :response-time ms';
    if (isNaN(loggingLevel) || loggingLevel > 2 || loggingLevel < 0)
        loggingLevel = 0;
    stdout = stdout || process.stdout;
    if (loggingLevel === 2)
        app.use(morgan_1.default(format, {
            stream: stdout,
        }));
    else if (loggingLevel === 1)
        app.use(morgan_1.default(format, {
            stream: stdout,
            skip: (request, resonse) => express_1.response.statusCode < 400,
        }));
}
function initialize(app) {
    app.use(express_1.default.json());
    app.use(express_1.default.urlencoded({ extended: false }));
    app.use(express_1.default.static(path_1.default.join(__dirname, '..', 'public')));
    app.use(express_1.default.static(path_1.default.resolve(uikit, '..', '..')));
    app.use('/', index_1.router);
    app.use('/download', download_1.router);
    app.use('/upload', upload_1.router);
}
function handlers(app) {
    app.use(function (request, resonse, next) {
        const error = new Error('Resource not found');
        error.status = 404;
        return next(error);
    });
    app.use(function (error, request, response, next) {
        response.status(error.status).json({
            status: error.status,
            message: error.message,
        });
    });
}
function init(options = {
    loggingLevel: 0,
    stdout: process.stdout,
    restart: true,
    destination: path_1.default.resolve(__dirname, '..', 'uploads'),
}) {
    const app = express_1.default();
    if (options.loggingLevel)
        setLogging(app, options.loggingLevel, options.stdout);
    return new Promise((resolve, reject) => {
        if (options.restart === undefined)
            options.restart = true;
        require('./middleware/fileManager')
            .initFiles(options)
            .then(() => {
            initialize(app);
            handlers(app);
            resolve(app);
        })
            .catch((error) => reject(error));
    });
}
module.exports = init;
//# sourceMappingURL=index.js.map