"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.router = void 0;
const express_1 = __importDefault(require("express"));
const uploadManager_1 = require("../middleware/uploadManager");
const router = express_1.default.Router();
exports.router = router;
function uploadResponder(request, response, next) {
    if (request.method === 'POST') {
        const files = request.files;
        if (!files) {
            const error = new Error('Please choose files');
            error.status = 400;
            return next(error);
        }
        uploadManager_1.updateReceivedFiles(files);
        response.json(files.map(file => ({
            sentFileName: file.originalname,
            savedFileName: file.filename,
            size: file.size,
        })));
    }
    else {
        const error = new Error('Only POST requests are allowed on this route');
        error.status = 400;
        return next(error);
    }
}
router.all('/', uploadManager_1.saveFiles, uploadResponder);
router.all('/zip', uploadManager_1.saveZips, uploadResponder);
//# sourceMappingURL=upload.js.map